diff -ruaN linux-2.6.16.orig/drivers/video/console/fbcon.h linux-2.6.16/drivers/video/console/fbcon.h
--- linux-2.6.16.orig/drivers/video/console/fbcon.h	2006-03-19 21:53:29.000000000 -0800
+++ linux-2.6.16/drivers/video/console/fbcon.h	2006-06-17 19:09:36.000000000 -0700
@@ -26,6 +26,34 @@
     *    low-level frame buffer device
     */
 
+#ifdef CONFIG_BOOTSPLASH
+struct splash_data {
+    int splash_state;			/* show splash? */
+    int splash_color;			/* transparent color */
+    int splash_fg_color;		/* foreground color */
+    int splash_width;			/* width of image */
+    int splash_height;			/* height of image */
+    int splash_text_xo;			/* text area origin */
+    int splash_text_yo;
+    int splash_text_wi;			/* text area size */ 
+    int splash_text_he;
+    int splash_showtext;		/* silent/verbose mode */
+    int splash_boxcount;
+    int splash_percent;
+    int splash_overpaintok;		/* is it ok to overpaint boxes */
+    int splash_palcnt;
+    char *oldscreen_base;		/* pointer to top of virtual screen */
+    unsigned char *splash_boxes;
+    unsigned char *splash_jpeg;		/* jpeg */
+    unsigned char *splash_palette;	/* palette for 8-bit */
+
+    int splash_dosilent;		/* show silent jpeg */
+    unsigned char *splash_silentjpeg;
+    unsigned char *splash_sboxes;
+    int splash_sboxcount;
+};
+#endif
+
 struct display {
     /* Filled in by the low-level console driver */
     const u_char *fontdata;
diff -ruaN linux-2.6.16.orig/drivers/video/fbmem.c linux-2.6.16/drivers/video/fbmem.c
--- linux-2.6.16.orig/drivers/video/fbmem.c	2006-03-19 21:53:29.000000000 -0800
+++ linux-2.6.16/drivers/video/fbmem.c	2006-06-17 19:08:46.000000000 -0700
@@ -669,13 +669,19 @@
 		total_size = info->fix.smem_len;
 
 	if (p > total_size)
-		return 0;
+		return -EFBIG;
 
-	if (count >= total_size)
+	if (count > total_size) {
+		err = -EFBIG;
 		count = total_size;
+	}
+
+	if (count + p > total_size) {
+		if (!err)
+			err = -ENOSPC;
 
-	if (count + p > total_size)
 		count = total_size - p;
+	}
 
 	buffer = kmalloc((count > PAGE_SIZE) ? PAGE_SIZE : count,
 			 GFP_KERNEL);
@@ -717,7 +723,7 @@
 
 	kfree(buffer);
 
-	return (err) ? err : cnt;
+	return (cnt) ? cnt : err;
 }
 
 #ifdef CONFIG_KMOD
diff -ruaN linux-2.6.16.orig/drivers/video/i810/i810_main.c linux-2.6.16/drivers/video/i810/i810_main.c
--- linux-2.6.16.orig/drivers/video/i810/i810_main.c	2006-03-19 21:53:29.000000000 -0800
+++ linux-2.6.16/drivers/video/i810/i810_main.c	2006-06-17 19:08:46.000000000 -0700
@@ -1508,7 +1508,7 @@
 		int size = ((cursor->image.width + 7) >> 3) *
 			cursor->image.height;
 		int i;
-		u8 *data = kmalloc(64 * 8, GFP_KERNEL);
+		u8 *data = kmalloc(64 * 8, GFP_ATOMIC);
 
 		if (data == NULL)
 			return -ENOMEM;
diff -ruaN linux-2.6.16.orig/drivers/video/Kconfig linux-2.6.16/drivers/video/Kconfig
--- linux-2.6.16.orig/drivers/video/Kconfig	2006-03-19 21:53:29.000000000 -0800
+++ linux-2.6.16/drivers/video/Kconfig	2006-06-17 19:09:36.000000000 -0700
@@ -1458,5 +1458,9 @@
 	source "drivers/video/backlight/Kconfig"
 endif
 
+if FB
+	source "drivers/video/bootsplash/Kconfig"
+endif
+
 endmenu
 
